#ifndef __cross
#define __cross

#include <blitz/array.h>

template<typename FT> blitz::Array<FT, 1> cross(const blitz::Array<FT, 1>& v1,
  const blitz::Array<FT, 1>& v2) {
  blitz::Array<FT, 1> v(3);
  v = v1(1)*v2(2) - v1(2)*v2(1), v1(2)*v2(0) - v1(0)*v2(2), v1(0)*v2(1) - v1(1)*v2(0);
  return v;
}

template<typename FT> FT dot(const blitz::Array<FT, 1>& v1,
  const blitz::Array<FT, 1>& v2) {
  return v1(0) * v2(0) + v1(1) * v2(1) + v1(2) * v2(2);
}

#endif
