#ifndef __intersection
#define __intersection

#include <blitz/array.h>
#include <linearequation.h>

template<typename FT> blitz::Array<FT, 1> Intersection(
  const blitz::Array<FT, 1>& center1, const blitz::Array<FT, 1>& dir1,
  const blitz::Array<FT, 1>& center2, const blitz::Array<FT, 1>& dir2) {
  blitz::Array<FT, 2> equation(3, 3);
  equation = dir1(0), -dir2(0), center2(0) - center1(0),
             dir1(1), -dir2(1), center2(1) - center1(1),
             dir1(2), -dir2(2), center2(2) - center1(2);
  LinearEquation(equation, 2);
  blitz::Array<FT, 1> result(3);
  result = center1 + dir1 * equation(0, 2);
  return result;
}

#endif
